using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;
public partial class PeriodAttendanceReport : System.Web.UI.Page
{
    private ReportDocument report;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            CalendarAttend.SelectedDate = DateTime.Now.Date;
            SqlDataAdapter myadapter = new SqlDataAdapter();

            SqlConnection myconnection = new SqlConnection();
            myconnection.ConnectionString = "data source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|DatabaseAutomation.mdf;User Instance=true";

            SqlCommand selCmd = new SqlCommand();
            selCmd.CommandText = "SELECT * FROM BRANCH";
            selCmd.Connection = myconnection;

            DataSetPeriodAttendance dsDataSet = new DataSetPeriodAttendance();

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "BRANCH");
            drpbranch.DataSource = dsDataSet.BRANCH;
            drpbranch.DataTextField = "BRANCHSHORTFORM";
            drpbranch.DataValueField = "BRANCHSNO";
            drpbranch.DataBind();




            selCmd.CommandText = "SELECT * FROM SEM";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "SEM");
            drpsem.DataSource = dsDataSet.SEM;
            drpsem.DataTextField = "SEMSNO";
            drpsem.DataValueField = "SEMSNO";
            drpsem.DataBind();



            selCmd.CommandText = "SELECT * FROM DEGREE";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "DEGREE");

            drpdegree.DataSource = dsDataSet.DEGREE;
            drpdegree.DataTextField = "DEGREESHORTFORM";
            drpdegree.DataValueField = "DEGREESNO";
            drpdegree.DataBind();

            selCmd.CommandText = "SELECT * FROM SECTION";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "SECTION");
            drpsection.DataSource = dsDataSet.SECTION;
            drpsection.DataTextField = "SECTION";
            drpsection.DataValueField = "SECTIONSNO";
            drpsection.DataBind();


            selCmd.CommandText = "SELECT * FROM REGULATION";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "REGULATION");
            drpregulation.DataSource = dsDataSet.REGULATION;
            drpregulation.DataTextField = "REGULATION";
            drpregulation.DataValueField = "REGULATIONSNO";
            drpregulation.DataBind();


            
         
            selCmd.CommandText = "SELECT t.PERIODNO FROM TIMETABLE AS t INNER JOIN TIMETABLEGENERAL AS tg ON tg.TIMETABLESNO = t.TIMETABLESNO   WHERE  (tg.REGULATIONSNO = @REGULATIONSNO) AND (tg.DEGREESNO = @DEGREESNO) AND (tg.BRANCHSNO = @BRANCHSNO)AND (tg.SEMSNO = @SEMSNO)AND (tg.SECTIONSNO = @SECTIONSNO) ORDER BY PERIODNO";
            selCmd.Connection = myconnection;

            selCmd.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
            selCmd.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
            selCmd.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
            selCmd.Parameters.Add("@SEMSNO", SqlDbType.Int, 4, "SEMSNO");
            selCmd.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");


            selCmd.Parameters["@REGULATIONSNO"].Value = drpregulation.SelectedValue;
            selCmd.Parameters["@DEGREESNO"].Value =drpdegree.SelectedValue;
            selCmd.Parameters["@BRANCHSNO"].Value =drpbranch.SelectedValue;
            selCmd.Parameters["@SEMSNO"].Value =drpsem.SelectedValue;
            selCmd.Parameters["@SECTIONSNO"].Value =drpsection.SelectedValue;


           
            DataSet dsDataSetPeriod = new DataSet();
            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSetPeriod, "TIMETABLE");
            drpdownperiod.DataSource = dsDataSetPeriod; 
            drpdownperiod.DataTextField = "PERIODNO";
            drpdownperiod.DataValueField = "PERIODNO";
            drpdownperiod.DataBind();
            
            
            
            
            
            CrystalReportViewerPeriodAttendance.Visible = false;

        }

        ConfigureCrystalReports(); 
    }
    protected void btnViewReport_Click(object sender, EventArgs e)
    {
        CrystalReportViewerPeriodAttendance.Visible =true;
    }
    private void ConfigureCrystalReports()
    {
        DataSetPeriodAttendance mydatasetattendance = new DataSetPeriodAttendance();
       


        SqlDataAdapter myadapter = new SqlDataAdapter();

        SqlConnection myconnection = new SqlConnection();
        myconnection.ConnectionString = "data source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|DatabaseAutomation.mdf;User Instance=true";

        SqlCommand selCmd = new SqlCommand();
        selCmd.CommandText = "SELECT * from ATTENDANCEMAINTAIN AS am INNER JOIN ATTENDANCE AS a ON a.ATTENDANCESNO=am.ATTENDANCESNO WHERE  (a.DEGREESNO = @DEGREESNO) AND (a.BRANCHSNO = @BRANCHSNO) AND (a.SECTIONSNO = @SECTIONSNO) AND (a.SEMSNO = @SEMSNO) AND(a.REGULATIONSNO = @REGULATIONSNO) AND (a.DATE = @DATE)AND (a.PERIODNO = @PERIODNO) ORDER BY ABSENTROLLNO";
        
        selCmd.Connection = myconnection;

        selCmd.Connection = myconnection;
        selCmd.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
        selCmd.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
        selCmd.Parameters.Add("@SEMSNO", SqlDbType.Int, 4, "SEMSNO");
        selCmd.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");
        selCmd.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
        selCmd.Parameters.Add("@DATE", SqlDbType.DateTime, 8, "DATE");
        selCmd.Parameters.Add("@PERIODNO", SqlDbType.Int, 4, "PERIODNO");


       
       
        myadapter.SelectCommand = selCmd;
        selCmd.Parameters["@BRANCHSNO"].Value = drpbranch.SelectedValue;
        selCmd.Parameters["@DEGREESNO"].Value = drpdegree.SelectedValue;
        selCmd.Parameters["@SEMSNO"].Value = drpsem.SelectedValue;
        selCmd.Parameters["@SECTIONSNO"].Value = drpsection.SelectedValue;
        selCmd.Parameters["@REGULATIONSNO"].Value = drpregulation.SelectedValue;
        selCmd.Parameters["@DATE"].Value = CalendarAttend.SelectedDate;
        selCmd.Parameters["@PERIODNO"].Value = drpdownperiod.SelectedValue;
       

        try
        {
            myadapter.Fill(mydatasetattendance, "ATTENDANCEMAINTAIN");
        }
        catch
        {

        }
        mydatasetattendance.AcceptChanges();
        DataSetPeriodAttendance.PeriodAttendanceDataTable perioddatatable = mydatasetattendance.PeriodAttendance;
       

        for (int i = 0; i < mydatasetattendance.ATTENDANCEMAINTAIN.Rows.Count; i++)
        {
            DataSetPeriodAttendance.PeriodAttendanceRow periodrow = perioddatatable.NewPeriodAttendanceRow();

            if (Convert.ToInt32(mydatasetattendance.ATTENDANCEMAINTAIN.DefaultView[i][1]) == -1)
            {
                periodrow.Roll_No = "null(all present)";
                periodrow.Name = "null";

            }

            else
            {
                string studentname = getstudentname(Convert.ToInt32(mydatasetattendance.ATTENDANCEMAINTAIN.DefaultView[i][1]));
                periodrow.Roll_No = Convert.ToString(mydatasetattendance.ATTENDANCEMAINTAIN.DefaultView[i][1]);
                periodrow.Name = studentname;
            }

            perioddatatable.AddPeriodAttendanceRow(periodrow);

        }


        mydatasetattendance.AcceptChanges();




       



        SqlCommand selCommand = new SqlCommand();
        selCommand.CommandText = "SELECT * FROM BRANCH WHERE BRANCHSNO = @BRANCHSNO";
        selCommand.Connection = myconnection;
        try
        {
            selCommand.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
            selCommand.Parameters["@BRANCHSNO"].Value = Convert.ToInt32(drpbranch.SelectedValue);

            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "BRANCH");
        }
        catch
        {

        }


        selCommand.CommandText = "SELECT * FROM SEM WHERE SEMSNO = @SEMSNO";
        selCommand.Connection = myconnection;
        try
        {
            selCommand.Parameters.Add("@SEMSNO", SqlDbType.Int, 4, "SEMSNO");
            selCommand.Parameters["@SEMSNO"].Value = Convert.ToInt32(drpsem.SelectedValue);
            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "SEM");
            selCommand.Connection = myconnection;
        }

        catch
        {

        }


        selCommand.CommandText = "SELECT * FROM DEGREE WHERE DEGREESNO = @DEGREESNO";
        selCommand.Connection = myconnection;
        try
        {
            selCommand.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
            selCommand.Parameters["@DEGREESNO"].Value = Convert.ToInt32(drpdegree.SelectedValue);
            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "DEGREE");
        }
        catch
        {
        }



        selCommand.CommandText = "SELECT * FROM SECTION WHERE SECTIONSNO = @SECTIONSNO";
        selCommand.Connection = myconnection;
        try
        {
            selCommand.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");
            selCommand.Parameters["@SECTIONSNO"].Value = Convert.ToInt32(drpsection.SelectedValue);
            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "SECTION");
        }
        catch
        {
        }

        selCommand.CommandText = "SELECT * FROM REGULATION WHERE REGULATIONSNO = @REGULATIONSNO";
        selCommand.Connection = myconnection;

        try
        {
            selCommand.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
            selCommand.Parameters["@REGULATIONSNO"].Value = Convert.ToInt32(drpregulation.SelectedValue);


            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "REGULATION");

        }

        catch
        {
        }





        DataSetPeriodAttendance.AttendanceDateDataTable  Datetable = mydatasetattendance.AttendanceDate;

        try
        {
            DataSetPeriodAttendance.AttendanceDateRow myrowDate = Datetable.NewAttendanceDateRow();


            myrowDate.BeginEdit();

            myrowDate.Date = CalendarAttend.SelectedDate;

            myrowDate.EndEdit();

            Datetable.AddAttendanceDateRow(myrowDate);

        }
        catch
        {
        }

        mydatasetattendance.AcceptChanges();


        DataSetPeriodAttendance.PeriodnoDataTable tablePeriodno = mydatasetattendance.Periodno;

        try
        {
            DataSetPeriodAttendance.PeriodnoRow myrowPeriod = tablePeriodno.NewPeriodnoRow();


            myrowPeriod.BeginEdit();

            myrowPeriod.Period_No = Convert.ToString(drpdownperiod.SelectedValue);

            myrowPeriod.EndEdit();

            tablePeriodno.AddPeriodnoRow(myrowPeriod);

        }
        catch
        {
        }

        mydatasetattendance.AcceptChanges();




        










       
        try
        {
            report = new ReportDocument();
            string reportPath = Server.MapPath("CrystalReportPeriodAttendance.rpt");
            report.Load(reportPath);

            report.SetDataSource(mydatasetattendance);

            CrystalReportViewerPeriodAttendance.ReportSource = report;
        }
        catch
        {
        }
    }


    string getstudentname(int roll)
    {
        SqlDataAdapter myadapter = new SqlDataAdapter();

        SqlConnection myconnection = new SqlConnection();
        myconnection.ConnectionString = "data source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|DatabaseAutomation.mdf;User Instance=true";

        SqlCommand selCmd = new SqlCommand();


        selCmd.CommandText = "SELECT sp.NAME FROM STUDENTPERSONALDETAILS AS sp INNER JOIN STUDENTROLLNO AS sr ON sr.STUDENTPERSONALSNO = sp.STUDENTPERSONALSNO  WHERE  (sr.REGULATIONSNO = @REGULATIONSNO) AND (sr.DEGREESNO = @DEGREESNO) AND (sr.BRANCHSNO = @BRANCHSNO) AND (sr.SECTIONSNO = @SECTIONSNO)AND (sr.ROLLNO = @ROLLNO)";
        selCmd.Connection = myconnection;

        selCmd.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
        selCmd.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
        selCmd.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
        selCmd.Parameters.Add("@ROLLNO", SqlDbType.Int, 4, "ROLLNO");
        selCmd.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");


        selCmd.Parameters["@REGULATIONSNO"].Value = drpregulation.SelectedValue;
        selCmd.Parameters["@DEGREESNO"].Value = drpdegree.SelectedValue;
        selCmd.Parameters["@BRANCHSNO"].Value = drpbranch.SelectedValue;
        selCmd.Parameters["@ROLLNO"].Value = roll;
        selCmd.Parameters["@SECTIONSNO"].Value = drpsection.SelectedValue;



        DataSet dsDataSetPeriod = new DataSet();
      
        myadapter.SelectCommand = selCmd;
        myadapter.Fill(dsDataSetPeriod, "TIMETABLE");
        
        return Convert.ToString( dsDataSetPeriod.Tables[0].DefaultView[0][0]);
            
            
            
    }
    private void Page_Init(object sender, EventArgs e)
    {
       

    }
}
