using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using CrystalDecisions.CrystalReports.Engine;
using CrystalDecisions.Shared;

public partial class DailyAttendanceReport : System.Web.UI.Page
{
    private ReportDocument report;

    protected void Page_Load(object sender, EventArgs e)
    {
       
       
        if (!IsPostBack)
        {
            CalendarAttend.SelectedDate = DateTime.Now.Date;
            SqlDataAdapter myadapter = new SqlDataAdapter();

            SqlConnection myconnection = new SqlConnection();
            myconnection.ConnectionString = "data source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|DatabaseAutomation.mdf;User Instance=true";

            SqlCommand selCmd = new SqlCommand();
            selCmd.CommandText = "SELECT * FROM BRANCH";
            selCmd.Connection = myconnection;

            DataSetDailyattendance dsDataSet = new DataSetDailyattendance();
         
            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "BRANCH");
            drpbranch.DataSource = dsDataSet.BRANCH;
            drpbranch.DataTextField = "BRANCHSHORTFORM";
            drpbranch.DataValueField = "BRANCHSNO";
            drpbranch.DataBind();




            selCmd.CommandText = "SELECT * FROM SEM";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "SEM");
            drpsem.DataSource = dsDataSet.SEM;
            drpsem.DataTextField = "SEMSNO";
            drpsem.DataValueField = "SEMSNO";
            drpsem.DataBind();



            selCmd.CommandText = "SELECT * FROM DEGREE";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "DEGREE");

            drpdegree.DataSource = dsDataSet.DEGREE;
            drpdegree.DataTextField = "DEGREESHORTFORM";
            drpdegree.DataValueField = "DEGREESNO";
            drpdegree.DataBind();

            selCmd.CommandText = "SELECT * FROM SECTION";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "SECTION");
            drpsection.DataSource = dsDataSet.SECTION;
            drpsection.DataTextField = "SECTION";
            drpsection.DataValueField = "SECTIONSNO";
            drpsection.DataBind();


            selCmd.CommandText = "SELECT * FROM REGULATION";
            selCmd.Connection = myconnection;

            myadapter.SelectCommand = selCmd;
            myadapter.Fill(dsDataSet, "REGULATION");
            drpregulation.DataSource = dsDataSet.REGULATION;
            drpregulation.DataTextField = "REGULATION";
            drpregulation.DataValueField = "REGULATIONSNO";
            drpregulation.DataBind();
           
          CrystalReportViewerDailyAttendance.Visible = false;

        }

        ConfigureCrystalReports(); 
    }
    protected void btnViewReport_Click(object sender, EventArgs e)
    {

        CrystalReportViewerDailyAttendance.Visible = true;

       // ConfigureCrystalReports();
    }

    private void ConfigureCrystalReports()
    {

        
       SqlDataAdapter myadapter = new SqlDataAdapter();

        SqlConnection myconnection = new SqlConnection();
        myconnection.ConnectionString = "data source=.\\SQLEXPRESS;Integrated Security=SSPI;AttachDBFilename=|DataDirectory|DatabaseAutomation.mdf;User Instance=true";

        SqlCommand selCmd = new SqlCommand();
        selCmd.CommandText = "SELECT a.PERIODNO,s.SUBJECTNAME,am.ABSENTROLLNO from ATTENDANCE AS a INNER JOIN SUBJECT AS s ON a.SUBJECTSNO=s.SUBJECTSNO FULL OUTER JOIN ATTENDANCEMAINTAIN am on a.ATTENDANCESNO=am.ATTENDANCESNO WHERE  (a.DEGREESNO = @DEGREESNO) AND (a.BRANCHSNO = @BRANCHSNO) AND (a.SECTIONSNO = @SECTIONSNO) AND (a.SEMSNO = @SEMSNO) AND(a.REGULATIONSNO = @REGULATIONSNO) AND (a.DATE = @DATE) ORDER BY PERIODNO";

        selCmd.Connection = myconnection;

        selCmd.Connection = myconnection;
        selCmd.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
        selCmd.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
        selCmd.Parameters.Add("@SEMSNO", SqlDbType.Int, 4, "SEMSNO");
        selCmd.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");     
        selCmd.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
        selCmd.Parameters.Add("@DATE", SqlDbType.DateTime, 8, "DATE");


        DataSet MY = new DataSet();

        myadapter.SelectCommand = selCmd;
        selCmd.Parameters["@BRANCHSNO"].Value =drpbranch.SelectedValue;
        selCmd.Parameters["@DEGREESNO"].Value =drpdegree.SelectedValue;
        selCmd.Parameters["@SEMSNO"].Value =drpsem.SelectedValue;
        selCmd.Parameters["@SECTIONSNO"].Value =drpsection.SelectedValue;    
        selCmd.Parameters["@REGULATIONSNO"].Value =drpregulation.SelectedValue;
        selCmd.Parameters["@DATE"].Value = CalendarAttend.SelectedDate;

        try
        {
            myadapter.Fill(MY, "ATTENDANCE");
        }
        catch
        {
        }

        MY.AcceptChanges();


        DataTable table = new DataTable("datatableabsentgrid");
        DataColumn column;
        DataRow row;

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "PeriodNo";
        column.Unique = true;
        column.ReadOnly = true;
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Subject";
        column.AllowDBNull = true;
        column.ReadOnly = true;
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "AbsentRollno";
        column.AllowDBNull = true;
        table.Columns.Add(column);
        int datasetrowcount;
        try
        {
             datasetrowcount = MY.Tables[0].Rows.Count;
        }
        catch
        {
            datasetrowcount = 0;
        }

        if (datasetrowcount != 0)
        {
            int datatblcount = Convert.ToInt32(MY.Tables[0].Rows.Count);
            for (int i = 0; i < datatblcount; i++)
            {
                row = table.NewRow();
                try
                {

                    row["PeriodNo"] = Convert.ToInt32(MY.Tables[0].DefaultView[i][0]);
                    row["Subject"] = Convert.ToString(MY.Tables[0].DefaultView[i][1]);
                    if (Convert.ToString(MY.Tables[0].DefaultView[i][2]) == "-1")
                    {
                        row["AbsentRollno"] = "AllPresent";
                    }
                    else
                    {
                        row["AbsentRollno"] = Convert.ToString(MY.Tables[0].DefaultView[i][2]);
                    }
                    table.Rows.Add(row);


                }
                catch
                {


                    for (int j = 0; j < table.Rows.Count; j++)
                    {
                        if (Convert.ToInt32(MY.Tables[0].DefaultView[i][0]) == Convert.ToInt32(table.DefaultView[j][0]))
                        {
                            String str = Convert.ToString(table.DefaultView[j][2]);
                            table.DefaultView[j][2] = str + "," + Convert.ToString(MY.Tables[0].DefaultView[i][2]);
                        }

                    }


                }


            }
        }

        DataSetDailyattendance mydatasetattendance = new DataSetDailyattendance();
        DataSetDailyattendance.DailyAttendanceDataTable mytable = mydatasetattendance.DailyAttendance;

        for (int i = 0; i < table.Rows.Count; i++)
        {
            DataSetDailyattendance.DailyAttendanceRow myrowattendance = mytable.NewDailyAttendanceRow();

            myrowattendance.BeginEdit();

            myrowattendance.PeriodNo =Convert.ToInt32( table.DefaultView[i][0]);
            myrowattendance.Subject =Convert.ToString( table.DefaultView[i][1]);
            myrowattendance.AbsentRollno =Convert.ToString( table.DefaultView[i][2]);

            myrowattendance.EndEdit();

            mytable.AddDailyAttendanceRow(myrowattendance);

        }

        mydatasetattendance.AcceptChanges();



       
        SqlCommand selCommand = new SqlCommand();
        selCommand.CommandText = "SELECT * FROM BRANCH WHERE BRANCHSNO = @BRANCHSNO";
        selCommand.Connection = myconnection;
        try
        {
            selCommand.Parameters.Add("@BRANCHSNO", SqlDbType.Int, 4, "BRANCHSNO");
            selCommand.Parameters["@BRANCHSNO"].Value = Convert.ToInt32(drpbranch.SelectedValue);

            myadapter.SelectCommand = selCommand;
            myadapter.Fill(mydatasetattendance, "BRANCH");
        }
        catch
        {

        }


            selCommand.CommandText = "SELECT * FROM SEM WHERE SEMSNO = @SEMSNO";
            selCommand.Connection = myconnection;
            try
            {
                selCommand.Parameters.Add("@SEMSNO", SqlDbType.Int, 4, "SEMSNO");
                selCommand.Parameters["@SEMSNO"].Value = Convert.ToInt32(drpsem.SelectedValue);
                myadapter.SelectCommand = selCommand;
                myadapter.Fill(mydatasetattendance, "SEM");
                selCommand.Connection = myconnection;
            }

            catch
            {

            }


            selCommand.CommandText = "SELECT * FROM DEGREE WHERE DEGREESNO = @DEGREESNO";
            selCommand.Connection = myconnection;
            try
            {
                selCommand.Parameters.Add("@DEGREESNO", SqlDbType.Int, 4, "DEGREESNO");
                selCommand.Parameters["@DEGREESNO"].Value = Convert.ToInt32(drpdegree.SelectedValue);
                myadapter.SelectCommand = selCommand;
                myadapter.Fill(mydatasetattendance, "DEGREE");
            }
            catch
            {
            }



            selCommand.CommandText = "SELECT * FROM SECTION WHERE SECTIONSNO = @SECTIONSNO";
            selCommand.Connection = myconnection;
            try
            {
                selCommand.Parameters.Add("@SECTIONSNO", SqlDbType.Int, 4, "SECTIONSNO");
                selCommand.Parameters["@SECTIONSNO"].Value = Convert.ToInt32(drpsection.SelectedValue);
                myadapter.SelectCommand = selCommand;
                myadapter.Fill(mydatasetattendance, "SECTION");
            }
            catch
            {
            }

            selCommand.CommandText = "SELECT * FROM REGULATION WHERE REGULATIONSNO = @REGULATIONSNO";
            selCommand.Connection = myconnection;

            try
            {
                selCommand.Parameters.Add("@REGULATIONSNO", SqlDbType.Int, 4, "REGULATIONSNO");
                selCommand.Parameters["@REGULATIONSNO"].Value = Convert.ToInt32(drpregulation.SelectedValue);


                myadapter.SelectCommand = selCommand;
                myadapter.Fill(mydatasetattendance, "REGULATION");

            }

            catch
            {
            }


       
        DataSetDailyattendance.AttendanceDateDataTable Datetable = mydatasetattendance.AttendanceDate;

        try
        {
            DataSetDailyattendance.AttendanceDateRow myrowDate = Datetable.NewAttendanceDateRow();


            myrowDate.BeginEdit();

            myrowDate.Date = CalendarAttend.SelectedDate;

            myrowDate.EndEdit();

            Datetable.AddAttendanceDateRow(myrowDate);

        }
        catch
        {
        }

        mydatasetattendance.AcceptChanges();







        mydatasetattendance.AcceptChanges();


        





        

        report = new ReportDocument();

        string reportPath = Server.MapPath("CrystalReportDailyAttendance.rpt");
        report.Load(reportPath);

        report.SetDataSource(mydatasetattendance);
      CrystalReportViewerDailyAttendance.ReportSource = report;
      

    }




    private void Page_Init(object sender, EventArgs e)
    {
       // ConfigureCrystalReports();

    }

}
